SystemOrganization addCategory: #'Monticello2-Elements'!
SystemOrganization addCategory: #'Monticello2-Tests'!

TestCase subclass: #MDTestMockImageProxy
	instanceVariableNames: 'proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDTestMockImageProxy methodsFor: 'tests' stamp: 'cwp 11/28/2004 12:49'!
testCurrentDefinition
	| snap |
	proxy at: #method1 put: '1'.
	snap _ self methodSnapshot: #method1.
	proxy updateSnapshot: snap.
	self assert: snap element selector = #method1.
	self assert: (snap properties at: #source) = '1'.! !

!MDTestMockImageProxy methodsFor: 'tests' stamp: 'avi 11/28/2004 16:05'!
testLoadDefinition
	| snap |
	snap _ self methodSnapshot: #method1.
	snap properties at: #source put: '2'.
	proxy loadSnapshot: snap.
	self assert: (proxy at: #method1) = '2'! !

!MDTestMockImageProxy methodsFor: 'running' stamp: 'avi 11/28/2004 15:00'!
setUp
	proxy _ MDMockImageProxy new! !

!MDTestMockImageProxy methodsFor: 'running' stamp: 'cwp 11/28/2004 12:53'!
methodSnapshot: aSymbol
	^ MDElementDefinition forElement: (MDMethodElement className: 'Test' selector: aSymbol)! !

Object subclass: #MDProgramElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

MDProgramElement subclass: #MDMethodElement
	instanceVariableNames: 'className selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDMethodElement methodsFor: 'image proxy' stamp: 'cwp 11/28/2004 13:01'!
update: propDict from: anImageProxy
	anImageProxy update: propDict forMethodElement: self! !

!MDMethodElement methodsFor: 'initialize-release' stamp: 'avi 11/28/2004 16:02'!
initializeWithClassName: aString selector: aSymbol
	className _ aString.
	selector _ aSymbol! !

!MDMethodElement methodsFor: 'accessing' stamp: 'avi 11/28/2004 16:26'!
selector
	^ selector! !

!MDMethodElement methodsFor: 'accessing' stamp: 'avi 11/28/2004 16:26'!
className
	^ className! !

!MDMethodElement class methodsFor: 'as yet unclassified' stamp: 'avi 11/28/2004 16:02'!
className: aString selector: aSymbol
	^ self basicNew initializeWithClassName: aString selector: aSymbol! !

!MDMethodElement methodsFor: 'image proxy' stamp: 'cwp 11/28/2004 12:59'!
load: propDict into: anImageProxy
	anImageProxy load: propDict forMethodElement: self! !

!MDProgramElement methodsFor: 'comparing' stamp: 'avi 11/28/2004 16:02'!
= other
	self subclassResponsibility ! !

!MDProgramElement methodsFor: 'comparing' stamp: 'avi 11/28/2004 16:02'!
hash
	self subclassResponsibility ! !

!MDProgramElement methodsFor: 'image proxy' stamp: 'avi 11/28/2004 16:08'!
update: propDict from: anImageProxy
	self subclassResponsibility! !

!MDProgramElement methodsFor: 'image proxy' stamp: 'avi 11/28/2004 16:08'!
load: propDict into: anImageProxy
	self subclassResponsibility! !

Object subclass: #MDElementDefinition
	instanceVariableNames: 'element properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDElementDefinition methodsFor: 'accessing' stamp: 'avi 11/28/2004 16:06'!
properties
	^ properties! !

!MDElementDefinition class methodsFor: 'instance creation' stamp: 'cwp 11/28/2004 12:52'!
forElement: anElement
	^ self basicNew initializeWithElement: anElement! !

!MDElementDefinition methodsFor: 'accessing' stamp: 'cwp 11/28/2004 12:56'!
element
	^ element! !

!MDElementDefinition methodsFor: 'initialize-release' stamp: 'cwp 11/28/2004 12:52'!
initializeWithElement: anElement
	element _ anElement.
	properties _ Dictionary new! !

!MDElementDefinition methodsFor: 'image proxy' stamp: 'cwp 11/28/2004 12:55'!
updateFrom: anImageProxy
	element update: properties from: anImageProxy! !

!MDElementDefinition methodsFor: 'image proxy' stamp: 'cwp 11/28/2004 12:54'!
loadInto: anImageProxy
	element load: properties into: anImageProxy! !

Object subclass: #MDImageProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

MDImageProxy subclass: #MDMockImageProxy
	instanceVariableNames: 'dict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDMockImageProxy methodsFor: 'public' stamp: 'cwp 11/28/2004 13:01'!
update: propDict forMethodElement: aMethodElement
	propDict at: #source put: (dict at: aMethodElement selector)! !

!MDMockImageProxy methodsFor: 'private' stamp: 'avi 11/28/2004 16:24'!
at: aSymbol
	^ dict at: aSymbol! !

!MDMockImageProxy methodsFor: 'public' stamp: 'cwp 11/28/2004 12:58'!
load: propDict forMethodElement: aMethodElement
	dict at: aMethodElement selector put: (propDict at: #source)! !

!MDMockImageProxy methodsFor: 'private' stamp: 'avi 11/28/2004 16:24'!
at: aSymbol put: aString
	dict at: aSymbol put: aString! !

!MDMockImageProxy methodsFor: 'initialize-release' stamp: 'avi 11/28/2004 16:23'!
initialize
	dict _ Dictionary new! !

!MDImageProxy methodsFor: 'public' stamp: 'avi 11/28/2004 16:07'!
loadSnapshot: aSnapshot
	aSnapshot loadInto: self! !

!MDImageProxy methodsFor: 'public' stamp: 'avi 11/28/2004 16:06'!
updateSnapshot: aSnapshot
	aSnapshot updateFrom: self! !
